diff --git a/tests/fax/sip/nse/configs/ast1/extensions.conf b/tests/fax/sip/nse/configs/ast1/extensions.conf
new file mode 100644
index 0000000..d5ad7e2
--- /dev/null
+++ b/tests/fax/sip/nse/configs/ast1/extensions.conf
@@ -0,0 +1,4 @@
+[default]
+exten => bob,1,NoOp()
+	  same => n,ReceiveFax(/tmp/fax.tif)
+	  same => n,Hangup()
diff --git a/tests/fax/sip/nse/configs/ast1/sip.conf b/tests/fax/sip/nse/configs/ast1/sip.conf
new file mode 100644
index 0000000..cccdff6
--- /dev/null
+++ b/tests/fax/sip/nse/configs/ast1/sip.conf
@@ -0,0 +1,8 @@
+[general]
+
+[alice]
+type=friend
+directmedia=no
+allow=!all,alaw,ulaw
+host=127.0.0.1:5061
+
diff --git a/tests/fax/sip/nse/sipp/nse.pcap b/tests/fax/sip/nse/sipp/nse.pcap
new file mode 100644
index 0000000000000000000000000000000000000000..afc91c74ae627df5bb2ec40f1194a7864111bdc9
GIT binary patch
diff --git a/tests/fax/sip/nse/sipp/nse.xml b/tests/fax/sip/nse/sipp/nse.xml
new file mode 100644
index 0000000..2b7bdc3
--- /dev/null
+++ b/tests/fax/sip/nse/sipp/nse.xml
@@ -0,0 +1,88 @@
+<?xml version="1.0" encoding="ISO-8859-1" ?>
+<!DOCTYPE scenario SYSTEM "sipp.dtd">
+
+<scenario name="NSE RTP">
+	<send retrans="500">
+		<![CDATA[
+			INVITE sip:bob@[remote_ip]:[remote_port] SIP/2.0
+			Via: SIP/2.0/[transport] [local_ip]:[local_port];branch=[branch]
+			Max-Forwards: 70
+			From: "alice" <sip:alice@[local_ip]:[local_port]>;tag=[call_number]
+			To: "bob" <sip:bob@[remote_ip]:[remote_port]>
+			Contact: "alice" <sip:alice@[local_ip]:[local_port]>
+			Call-ID: [call_id]
+			CSeq: [cseq] INVITE
+			Allow: INVITE, ACK, BYE, CANCEL, OPTIONS, INFO, NOTIFY, REFER
+			Supported: replaces
+			Expires: 240
+			User-Agent: Test
+			Content-Type: application/sdp
+			Content-Length: [len]
+
+			v=0
+			o=- 1621597 1621597 IN IP[local_ip_type] [local_ip]
+			s=-
+			c=IN IP[media_ip_type] [media_ip]
+			t=0 0
+			m=audio 16442 RTP/AVP 8 0 2 18 100 101
+			a=rtpmap:8 PCMA/8000
+			a=rtpmap:0 PCMU/8000
+			a=rtpmap:2 G726-32/8000
+			a=rtpmap:18 G729a/8000
+			a=rtpmap:100 NSE/8000
+			a=fmtp:100 192-193
+			a=rtpmap:101 telephone-event/8000
+			a=fmtp:101 0-15
+			a=ptime:20
+			a=sendrecv
+
+		]]>
+	</send>
+
+	<recv response="100" optional="true" />
+	<recv response="180" optional="true" />
+	<recv response="183" optional="true" />
+	<recv response="200" />
+
+	<send>
+		<![CDATA[
+			ACK sip:[remote_ip]:[remote_port] SIP/2.0
+			Via: SIP/2.0/[transport] [local_ip]:[local_port];branch=[branch]
+			From: "alice" <sip:alice@[remote_ip]>;tag=[call_number]
+			To: "bob" <sip:bob@[remote_ip];user=phone>[peer_tag_param]
+			CSeq: [cseq] ACK
+			Call-ID: [call_id]
+			User-Agent: Test
+			Max-Forwards: 70
+			Content-Length: 0
+		]]>
+	</send>
+
+	<!-- Send pcap audio data with a Cisco NSE in it event. -->
+	<nop>
+		<action>
+			<exec play_pcap_audio="tests/fax/sip/nse/sipp/nse.pcap" />
+		</action>
+	</nop>
+
+	<!-- Wait for the pcap to fully get sent. -->
+	<pause milliseconds="750"/>
+
+	<send retrans="500">
+		<![CDATA[
+			BYE sip:alice@[remote_ip]:[remote_port] SIP/2.0
+			Via: SIP/2.0/[transport] [local_ip]:[local_port];branch=[branch]
+			From: "alice" <sip:alice[local_ip]:[local_port]>;tag=[call_number]
+			To: "bob" <sip:bob@[remote_ip]:[remote_port]>[peer_tag_param]
+			Call-ID: [call_id]
+			CSeq: [cseq] BYE
+			Contact: "alice" <sip:alice@[local_ip]:[local_port];transport=[transport]>
+			Max-Forwards: 70
+			Subject: Test
+			Content-Length: 0
+		]]>
+	</send>
+
+	<recv response="200" />
+
+</scenario>
diff --git a/tests/fax/sip/nse/test-config.yaml b/tests/fax/sip/nse/test-config.yaml
new file mode 100644
index 0000000..910759a
--- /dev/null
+++ b/tests/fax/sip/nse/test-config.yaml
@@ -0,0 +1,28 @@
+testinfo:
+    summary: 'Test receiving a Cisco NSE RTP event packet when faxing'
+    description: |
+        'A remote crash can occur when an endpoint sends a fax to its extension
+         using the NSE option of a Cisco gateway. This test verifies that the
+         crash no longer occurs when an NSE RTP event packet is received.'
+
+properties:
+    minversion: ['15.1.5']
+    dependencies:
+        - sipp :
+            version : 'v3.5.1'
+        - asterisk : 'chan_sip'
+        - asterisk : 'res_fax'
+    tags:
+        - SIP
+
+test-modules:
+    test-object:
+        config-section: sipp-config
+        typename: 'sipp.SIPpTestCase'
+
+sipp-config:
+    reactor-timeout: 20
+    test-iterations:
+        -
+            scenarios:
+                - { 'key-args': {'scenario': 'nse.xml', '-p': '5061' } }
diff --git a/tests/fax/sip/tests.yaml b/tests/fax/sip/tests.yaml
index 58f7ef0..7712326 100644
--- a/tests/fax/sip/tests.yaml
+++ b/tests/fax/sip/tests.yaml
@@ -16,5 +16,6 @@ tests:
     - test: 'gateway_timeout3'
     - test: 'gateway_timeout4'
     - test: 'gateway_timeout5'
+    - test: 'nse'
     - test: 'voxfax_g711'
     - test: 't38_negotiation_timeout'